# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/03_preps.ipynb.

# %% auto 0
__all__ = ['prep__obj', 'prep__attr', 'prep__clc', 'prep__objcls', 'prep__pref', 'prep__hush', 'prep__verb', 'prep__key',
           'prep__keys', 'prep__def', 'prep__all']

# %% ../nbs/03_preps.ipynb 4
import inspect
from atyp import AnyQ, StrQ, BoolQ, ListQ, TypeQ
from typing import Tuple

from .utils import key1st
from .types import (AttrSrcsQ, AttrPrefQ)
from .enums import (AttrPref)

# %% ../nbs/03_preps.ipynb 5
def prep__obj(__o: AnyQ = None, **kwargs) -> AnyQ:
    obj = __o or key1st(kwargs, keys=['obj', '__o']) or None
    return obj

def prep__attr(__a: AnyQ = None, **kwargs) -> str:
    attr = __a or key1st(kwargs, keys=['attr', 'arg', '__a']) or ''
    return attr

def prep__clc(__c: TypeQ = None, **kwargs) -> TypeQ:
    cls = __c or key1st(kwargs, keys=['cls', '__c']) or None
    return cls

def prep__objcls(__o: AnyQ = None, __c: TypeQ = None, **kwargs) -> Tuple[AnyQ, TypeQ]:
    obj = prep__obj(__o, **kwargs)
    cls = prep__clc(__c, **kwargs)
    cls = cls or (obj if inspect.isclass(obj) else type(obj))
    return obj, cls,

def prep__pref(__p: AttrPrefQ = None, **kwargs) -> AttrPrefQ:
    pref = __p or key1st(kwargs, keys=['pref', '__p']) or None
    pref = pref or AttrPref.OKC
    return pref

def prep__hush(__h: BoolQ = None, **kwargs) -> BoolQ:
    hush = __h or key1st(kwargs, keys=['hush', 'quiet', 'raise', 'failq', '__h']) or False 
    return hush

def prep__verb(__v: BoolQ = None, **kwargs) -> BoolQ:
    verb = __v or key1st(kwargs, keys=['verbose', 'verb', 'print', '__v']) or False
    return verb

def prep__key(__k: str = None, **kwargs) -> StrQ:
    key = __k or key1st(kwargs, keys=['__key', '__k', ]) or ''
    return key

def prep__keys(__k: ListQ = None, **kwargs) -> ListQ:
    keys = __k or key1st(kwargs, keys=['__keys', '__ks', '__k', 'keys']) or []
    return keys

def prep__def(__d: AnyQ = None, **kwargs) -> AnyQ:
    keys = ['default', 'defval', f'{prep__key(**kwargs)}val', f'{__d}val', 'def', '__d', ]
    return __d or key1st(kwargs, keys) or None    
    # return kwargs.get('default', kwargs.get('defval', kwargs.get(f'{key}val', None)))

# %% ../nbs/03_preps.ipynb 6
def prep__all(
    __o: AnyQ = None,      # obj
    __a: StrQ = None,      # attr 
    __c: TypeQ = None,     # cls
    __p: AttrPrefQ = None, # pref
    __h: BoolQ = False,    # hush (don't raise exceptions)
    __v: BoolQ = False,    # verbose (print)
    **kwargs
) -> Tuple[AnyQ, StrQ, TypeQ, AttrSrcsQ, BoolQ, BoolQ, dict]:
    obj, cls = prep__objcls(__o, __c, **kwargs)
    attr = prep__attr(__a, **kwargs)
    pref = prep__pref(__p, **kwargs)
    hush = prep__hush(__h, **kwargs)
    verb = prep__verb(__v, **kwargs)    
    return obj, attr, cls, pref, hush, verb, kwargs

