# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/12_set.ipynb.

# %% auto 0
__all__ = ['setnil', 'setcur', 'setkws']

# %% ../nbs/12_set.ipynb 4
from atyp import AnyQ, TypeQ, ListQ
from .types import AttrPrefQ
from .kws import (nilkws)
from .rnk import (rankattrs)

# %% ../nbs/12_set.ipynb 6
def setnil(obj: AnyQ = None, **kwargs) -> AnyQ:
    '''Set attributes to None.'''
    for attr, none in nilkws(obj).items():
        setattr(obj, attr, none)
    return obj

def setcur(obj: AnyQ = None, **kwargs) -> AnyQ:
    '''Set attributes to current value or fallback to None.'''
    for attr, _ in nilkws(obj).items():            
        cur = getattr(obj, attr, None)
        new = kwargs.get(attr, cur)
        setattr(obj, attr, new)            
    return obj

# %% ../nbs/12_set.ipynb 7
def setkws(obj: AnyQ = None, cls: TypeQ = None, pref: AttrPrefQ = None, keys: ListQ = None, **kwargs):
    # does not override instance attribute, does override class attribute if in kwargs
    '''sets kws on cls if obj is None'''
    use = obj or cls
    for akey, aval in rankattrs(obj, cls, pref, keys, **kwargs).items():        
        setattr(use, akey, aval)
    return use
